Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/GanttChart.Designer.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/GanttChart.Designer.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/GanttChart.Designer.cs	(revision 6177)
@@ -0,0 +1,73 @@
+﻿namespace HeuristicLab.Problems.Scheduling.Views {
+  partial class GanttChart {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
+      System.Windows.Forms.DataVisualization.Charting.Legend legend1 = new System.Windows.Forms.DataVisualization.Charting.Legend();
+      System.Windows.Forms.DataVisualization.Charting.Series series1 = new System.Windows.Forms.DataVisualization.Charting.Series();
+      this.chart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
+      ((System.ComponentModel.ISupportInitialize)(this.chart)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // chart
+      // 
+      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      chartArea1.Name = "ChartArea1";
+      this.chart.ChartAreas.Add(chartArea1);
+      legend1.Name = "Legend";
+      this.chart.Legends.Add(legend1);
+      this.chart.Location = new System.Drawing.Point(0, 0);
+      this.chart.Name = "chart";
+      series1.ChartArea = "ChartArea1";
+      series1.ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.RangeBar;
+      series1.CustomProperties = "DrawingStyle=Cylinder";
+      series1.IsVisibleInLegend = false;
+      series1.Legend = "Legend";
+      series1.Name = "Series1";
+      series1.YValuesPerPoint = 2;
+      series1.YValueType = System.Windows.Forms.DataVisualization.Charting.ChartValueType.Time;
+      this.chart.Series.Add(series1);
+      this.chart.Size = new System.Drawing.Size(687, 347);
+      this.chart.TabIndex = 0;
+      this.chart.Text = "chart";
+      // 
+      // GanttChart
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.chart);
+      this.Name = "GanttChart";
+      this.Size = new System.Drawing.Size(687, 347);
+      ((System.ComponentModel.ISupportInitialize)(this.chart)).EndInit();
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private Visualization.ChartControlsExtensions.EnhancedChart chart;
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/GanttChart.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/GanttChart.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/GanttChart.cs	(revision 6177)
@@ -0,0 +1,54 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Windows.Forms;
+using System.Windows.Forms.DataVisualization.Charting;
+
+namespace HeuristicLab.Problems.Scheduling.Views {
+  public partial class GanttChart : UserControl {
+
+    private IDictionary<string, Color> categories = new Dictionary<string, Color>();
+    private IDictionary<string, int> rowNames = new Dictionary<string, int>();
+
+    public GanttChart() {
+      InitializeComponent();
+    }
+
+    public void AddCategory(string name, Color color) {
+      if (!categories.ContainsKey(name)) {
+        categories[name] = color;
+        chart.Legends[0].CustomItems.Add(color, name);
+      }
+    }
+
+    public void AddData(string rowName, string category, double start, double end, string tooltip, bool showLabel = true) {
+      AddRowName(rowName);
+      var point = CreateDataPoint(rowNames[rowName], rowName, start, end, showLabel ? category : string.Empty, categories[category]);
+      point.ToolTip = tooltip;
+      chart.Series[0].Points.Add(point);
+    }
+
+    private void AddRowName(string rowName) {
+      if (!rowNames.ContainsKey(rowName)) {
+        int nextId = rowNames.Count == 0 ? 1 : rowNames.Values.Max() + 1;
+        rowNames.Add(rowName, nextId);
+      }
+    }
+
+    private static DataPoint CreateDataPoint(double x, string axisLabel, double start, double end, string text, Color color) {
+      var point = new DataPoint(x, new double[] { start, end });
+      point.Color = color;
+      point.Label = text;
+      point.AxisLabel = axisLabel;
+      return point;
+    }
+
+    public void Reset() {
+      chart.Series[0].Points.Clear();
+      categories.Clear();
+      chart.Legends[0].CustomItems.Clear();
+      rowNames.Clear();
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 6177)
@@ -36,4 +36,5 @@
     <Reference Include="System.Drawing" />
     <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Windows.Forms.DataVisualization" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -43,4 +44,10 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="GanttChart.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="GanttChart.Designer.cs">
+      <DependentUpon>GanttChart.cs</DependentUpon>
+    </Compile>
     <Compile Include="JobShopSchedulingProblemView.cs">
       <SubType>UserControl</SubType>
@@ -154,6 +161,13 @@
       <Name>HeuristicLab.Problems.VehicleRouting-3.3</Name>
     </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Visualization.ChartControlsExtensions\3.3\HeuristicLab.Visualization.ChartControlsExtensions-3.3.csproj">
+      <Project>{315BDA09-3F4F-49B3-9790-B37CFC1C5750}</Project>
+      <Name>HeuristicLab.Visualization.ChartControlsExtensions-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="GanttChart.resx">
+      <DependentUpon>GanttChart.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="JobShopSchedulingProblemView.resx">
       <DependentUpon>JobShopSchedulingProblemView.cs</DependentUpon>
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs	(revision 6177)
@@ -29,5 +29,5 @@
       this.tabPage1 = new System.Windows.Forms.TabPage();
       this.tabPage2 = new System.Windows.Forms.TabPage();
-      this.scheduleView1 = new HeuristicLab.Problems.Scheduling.Views.ScheduleView();
+      this.ganttChart = new HeuristicLab.Problems.Scheduling.Views.GanttChart();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tabControl1.SuspendLayout();
@@ -98,5 +98,5 @@
       // tabPage2
       // 
-      this.tabPage2.Controls.Add(this.scheduleView1);
+      this.tabPage2.Controls.Add(this.ganttChart);
       this.tabPage2.Location = new System.Drawing.Point(4, 22);
       this.tabPage2.Name = "tabPage2";
@@ -107,16 +107,10 @@
       this.tabPage2.UseVisualStyleBackColor = true;
       // 
-      // scheduleView1
+      // ganttChart
       // 
-      this.scheduleView1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.scheduleView1.Caption = "Schedule View";
-      this.scheduleView1.Content = null;
-      this.scheduleView1.Location = new System.Drawing.Point(0, 6);
-      this.scheduleView1.Name = "scheduleView1";
-      this.scheduleView1.ReadOnly = false;
-      this.scheduleView1.Size = new System.Drawing.Size(716, 381);
-      this.scheduleView1.TabIndex = 0;
+      this.ganttChart.Location = new System.Drawing.Point(0, 3);
+      this.ganttChart.Name = "ganttChart";
+      this.ganttChart.Size = new System.Drawing.Size(716, 384);
+      this.ganttChart.TabIndex = 0;
       // 
       // JobShopSchedulingProblemView
@@ -149,5 +143,5 @@
     private System.Windows.Forms.TabPage tabPage1;
     private System.Windows.Forms.TabPage tabPage2;
-    private ScheduleView scheduleView1;
+    private GanttChart ganttChart;
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.cs	(revision 6177)
@@ -28,4 +28,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.PluginInfrastructure;
+using System.Drawing;
 
 namespace HeuristicLab.Problems.Scheduling.Views {
@@ -47,8 +48,28 @@
       if (Content == null) {
         parameterCollectionView.Content = null;
-        scheduleView1.Content = null;
+        ganttChart.Reset();
       } else {
         parameterCollectionView.Content = ((IParameterizedNamedItem)Content).Parameters;
-        //TODO: display the current best solution in the view
+        FillGanttChart(Content);
+      }
+    }
+
+    private void FillGanttChart(JobShopSchedulingProblem content) {
+      //Add Jobs as Categories
+      int jobCount = 0;
+      Random random = new Random();
+      foreach (JSSPJob j in content.Jobs) {
+        foreach (JSSPTask t in content.Jobs[jobCount].Tasks) {
+          string categoryName = "ScheduleTasks";
+          categoryName = "Job" + t.Job.Index;
+          ganttChart.AddCategory(categoryName, Color.FromArgb(random.Next(255), random.Next(255), random.Next(255)));
+          ganttChart.AddData(categoryName,
+            categoryName,
+            t.StartTime.Value,
+            t.EndTime.Value,
+            "Job" + t.Job.Index + " - " + "Task#" + t.TaskNr.Value.ToString(), 
+            false);
+        }
+        jobCount++;
       }
     }
@@ -75,4 +96,5 @@
             Content.ImportSolution(spImportDialog.OptimalScheduleFileName);
            * */
+          OnContentChanged();
         }
         catch (Exception ex) {
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs	(revision 6177)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Scheduling.Views {
-  [Plugin("HeuristicLab.Problems.Scheduling.Views", "3.3.3.0")]
+  [Plugin("HeuristicLab.Problems.Scheduling.Views", "3.3.3.6121")]
   [PluginFile("HeuristicLab.Problems.Scheduling.Views-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabProblemsSchedulingViewsPlugin : PluginBase {
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs	(revision 6177)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.0.6121")]
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/ScheduleView.Designer.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/ScheduleView.Designer.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/ScheduleView.Designer.cs	(revision 6177)
@@ -24,5 +24,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
+      this.ganttChart = new HeuristicLab.Problems.Scheduling.Views.GanttChart();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
@@ -38,17 +38,13 @@
       this.infoLabel.Location = new System.Drawing.Point(510, 3);
       // 
-      // parameterCollectionView
+      // ganttChart
       // 
-      this.parameterCollectionView.AllowEditingOfHiddenParameters = true;
-      this.parameterCollectionView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+      this.ganttChart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.parameterCollectionView.Caption = "ParameterCollection View";
-      this.parameterCollectionView.Content = null;
-      this.parameterCollectionView.Location = new System.Drawing.Point(6, 29);
-      this.parameterCollectionView.Name = "parameterCollectionView";
-      this.parameterCollectionView.ReadOnly = false;
-      this.parameterCollectionView.Size = new System.Drawing.Size(498, 313);
-      this.parameterCollectionView.TabIndex = 3;
+      this.ganttChart.Location = new System.Drawing.Point(6, 22);
+      this.ganttChart.Name = "ganttChart";
+      this.ganttChart.Size = new System.Drawing.Size(520, 320);
+      this.ganttChart.TabIndex = 3;
       // 
       // ScheduleView
@@ -56,8 +52,8 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.parameterCollectionView);
+      this.Controls.Add(this.ganttChart);
       this.Name = "ScheduleView";
       this.Size = new System.Drawing.Size(529, 345);
-      this.Controls.SetChildIndex(this.parameterCollectionView, 0);
+      this.Controls.SetChildIndex(this.ganttChart, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
       this.Controls.SetChildIndex(this.nameTextBox, 0);
@@ -71,5 +67,6 @@
     #endregion
 
-    private Core.Views.ParameterCollectionView parameterCollectionView;
+    private GanttChart ganttChart;
+
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/ScheduleView.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/ScheduleView.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/ScheduleView.cs	(revision 6177)
@@ -48,7 +48,35 @@
       base.OnContentChanged();
       if (Content == null) {
-        parameterCollectionView.Content = null;
+        ResetGanttChart();
       } else {
-        parameterCollectionView.Content = ((IParameterizedNamedItem)Content).Parameters;
+        FillGanttChart(Content);
+      }
+    }
+
+    private void ResetGanttChart() {
+      ganttChart.Reset();
+    }
+
+    private void FillGanttChart(Schedule content) {
+      //Add Resources as Categories
+      int resCount = 0;
+      Random random = new Random ();
+      foreach (Resource r in content.Resources) {
+        foreach (JSSPTask t in content.Resources[resCount].Tasks) {
+          string categoryName = "ScheduleTasks";
+          string toolTip = "Task#" + t.TaskNr.Value.ToString();
+          if (t is JSSPTask) {
+            categoryName = "Job" + ((JSSPTask)t).Job.Index;
+            toolTip = categoryName + " - " + toolTip;
+          }
+          ganttChart.AddCategory(categoryName, Color.FromArgb(random.Next(255), random.Next(255), random.Next(255)));
+          ganttChart.AddData("Resource" + r.Index, 
+            categoryName, 
+            t.StartTime.Value, 
+            t.EndTime.Value, 
+            toolTip, 
+            false);
+        }
+        resCount++;
       }
     }
@@ -56,5 +84,5 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      parameterCollectionView.Enabled = Content != null;
+      ganttChart.Enabled = Content != null;
     }
   }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs	(revision 6177)
@@ -36,5 +36,5 @@
   [Item("BestSchedulingSolutionAnalyzer", "An operator for analyzing the best solution of Scheduling Problems given in schedule-representation.")]
   [StorableClass]
-  public sealed class BestSchedulingSolutionAnalyzer : SchedulingOperator, IAnalyzer, IStochasticOperator {
+  public sealed class BestSchedulingSolutionAnalyzer : JSSPOperator, IAnalyzer, IStochasticOperator {
     [StorableConstructor]
     private BestSchedulingSolutionAnalyzer(bool deserializing) : base(deserializing) { }
@@ -61,6 +61,6 @@
       get { return (ScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-    public LookupParameter<JSSPEncoding> BestSolutionParameter {
-      get { return (LookupParameter<JSSPEncoding>)Parameters["BestSolution"]; }
+    public LookupParameter<Schedule> BestSolutionParameter {
+      get { return (LookupParameter<Schedule>)Parameters["BestSolution"]; }
     }
     public ValueLookupParameter<ResultCollection> ResultsParameter {
@@ -70,9 +70,9 @@
       get { return (LookupParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
     }
-    public LookupParameter<JSSPEncoding> BestKnownSolutionParameter {
-      get { return (LookupParameter<JSSPEncoding>)Parameters["BestKnownSolution"]; }
+    public LookupParameter<Schedule> BestKnownSolutionParameter {
+      get { return (LookupParameter<Schedule>)Parameters["BestKnownSolution"]; }
     }
-    public ScopeTreeLookupParameter<JSSPEncoding> SchedulingSolutionParameter {
-      get { return (ScopeTreeLookupParameter<JSSPEncoding>)Parameters["SchedulingSolution"]; }
+    public ScopeTreeLookupParameter<Schedule> SchedulingSolutionParameter {
+      get { return (ScopeTreeLookupParameter<Schedule>)Parameters["DecodedSchedulingSolution"]; }
     }
 
@@ -84,17 +84,16 @@
       Parameters.Add(new LookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the JSSP solutions which should be analyzed."));
-      Parameters.Add(new ScopeTreeLookupParameter<JSSPEncoding>("SchedulingSolution", "The solutions from which the best solution has to be chosen from."));
-      Parameters.Add(new LookupParameter<JSSPEncoding>("BestSolution", "The best JSSP solution."));
+      Parameters.Add(new ScopeTreeLookupParameter<Schedule>("DecodedSchedulingSolution", "The solutions from which the best solution has to be chosen from."));
+      Parameters.Add(new LookupParameter<Schedule>("BestSolution", "The best JSSP solution."));
       Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The result collection where the best JSSP solution should be stored."));
       Parameters.Add(new LookupParameter<DoubleValue>("BestKnownQuality", "The quality of the best known solution of this JSSP instance."));
-      Parameters.Add(new LookupParameter<JSSPEncoding>("BestKnownSolution", "The best known solution of this JSSP instance."));
+      Parameters.Add(new LookupParameter<Schedule>("BestKnownSolution", "The best known solution of this JSSP instance."));
     }
 
 
     public override IOperation Apply() {
-      IntValue nrOfResources = NrOfResources;
       ItemList<JSSPJob> jobs = Jobs;
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
-      ItemArray<JSSPEncoding> solutions = SchedulingSolutionParameter.ActualValue;
+      ItemArray<Schedule> solutions = SchedulingSolutionParameter.ActualValue;
       ResultCollection results = ResultsParameter.ActualValue;
       bool max = MaximizationParameter.ActualValue.Value;
@@ -110,10 +109,10 @@
           !max && qualities[i].Value < bestKnownQuality.Value) {
         BestKnownQualityParameter.ActualValue = new DoubleValue(qualities[i].Value);
-        BestKnownSolutionParameter.ActualValue = (JSSPEncoding)solutions[i].Clone();
+        BestKnownSolutionParameter.ActualValue = (Schedule)solutions[i].Clone();
       }
 
-      JSSPEncoding bestSolution = BestSolutionParameter.ActualValue;
+      Schedule bestSolution = BestSolutionParameter.ActualValue;
       if (bestSolution == null) {
-        bestSolution = (JSSPEncoding)solutions[i].Clone();
+        bestSolution = (Schedule)solutions[i].Clone();
         bestSolution.Quality.Value = qualities [i].Value;
         BestSolutionParameter.ActualValue = bestSolution;
@@ -122,5 +121,5 @@
         if (max && bestSolution.Quality.Value < qualities[i].Value ||
           !max && bestSolution.Quality.Value > qualities[i].Value) {
-            bestSolution = (JSSPEncoding)solutions[i].Clone();
+            bestSolution = (Schedule)solutions[i].Clone();
           bestSolution.Quality.Value = qualities[i].Value;
         }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCreator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCreator.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCreator.cs	(revision 6177)
@@ -29,9 +29,10 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Problems.Scheduling.Encodings;
+using HeuristicLab.Problems.Scheduling.Interfaces;
 
 namespace HeuristicLab.Problems.Scheduling.Encodings {
   [Item("JobShop Scheduling Problem Creator", "Represents the generalized form of creators for JobShop Scheduling Problems.")]
   [StorableClass]
-  public abstract class JSSPCreator<T> : SchedulingCreator where T : JSSPEncoding{
+  public abstract class JSSPCreator<T> :JSSPOperator, IJSSPCreator where T : Item, IJSSPEncoding{
     [StorableConstructor]
     protected JSSPCreator(bool deserializing) : base(deserializing) { }
@@ -48,12 +49,10 @@
     }
 
+    protected abstract T CreateSolution();
+
     public override IOperation Apply() {
       SchedulingSolutionParameter.ActualValue = CreateSolution();
       return base.Apply();
     } 
-
-
-    protected abstract T CreateSolution();
-    
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCrossover.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCrossover.cs	(revision 6176)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCrossover.cs	(revision 6177)
@@ -25,18 +25,23 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Problems.Scheduling.Encodings {
   [Item("JSSPCrossover", "A scheduling crossover operation.")]
   [StorableClass]
-  public abstract class JSSPCrossover : SchedulingOperator, IJSSPCrossover {
+  public abstract class JSSPCrossover : JSSPOperator, IJSSPCrossover, IStochasticOperator {
     #region IJSSPCrossover Members
-    public ILookupParameter<ItemArray<JSSPEncoding>> ParentsParameter {
-      get { return (ScopeTreeLookupParameter<JSSPEncoding>)Parameters["Parents"]; }
+    public ILookupParameter<ItemArray<IJSSPEncoding>> ParentsParameter {
+      get { return (ScopeTreeLookupParameter<IJSSPEncoding>)Parameters["Parents"]; }
     }
 
-    public ILookupParameter<JSSPEncoding> ChildParameter {
-      get { return (ILookupParameter<JSSPEncoding>)Parameters["Child"]; }
+    public ILookupParameter<IJSSPEncoding> ChildParameter {
+      get { return (ILookupParameter<IJSSPEncoding>)Parameters["Child"]; }
     }
     #endregion
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
 
     [StorableConstructor]
@@ -47,7 +52,8 @@
     public JSSPCrossover()
       : base() {
-      Parameters.Add(new ScopeTreeLookupParameter<JSSPEncoding>("Parents", "The parent permutations which should be crossed."));
+        Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+      Parameters.Add(new ScopeTreeLookupParameter<IJSSPEncoding>("Parents", "The parent solution which should be crossed."));
       ParentsParameter.ActualName = "SchedulingSolution";
-      Parameters.Add(new LookupParameter<JSSPEncoding>("Child", "The child permutation resulting from the crossover."));
+      Parameters.Add(new LookupParameter<IJSSPEncoding>("Child", "The child solution resulting from the crossover."));
       ChildParameter.ActualName = "SchedulingSolution";
     }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPDecoder.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPDecoder.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPDecoder.cs	(revision 6177)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings {
+  public abstract class JSSPDecoder<T> : JSSPOperator, IJSSPDecoder where T : Item, IJSSPEncoding {
+    [StorableConstructor]
+    protected JSSPDecoder(bool deserializing) : base(deserializing) { }
+    protected JSSPDecoder(JSSPDecoder<T> original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public ILookupParameter<T> SchedulingSolutionParameter {
+      get { return (ILookupParameter<T>)Parameters["SchedulingSolution"]; }
+    }
+    public ILookupParameter<Schedule> DecodedSchedulingSolutionParameter {
+      get { return (ILookupParameter<Schedule>)Parameters["DecodedSchedulingSolution"]; }
+    }
+
+    public JSSPDecoder()
+      : base() {
+      Parameters.Add(new LookupParameter<T>("SchedulingSolution", "The new scheduling solution represented as encoding."));
+      Parameters.Add(new LookupParameter<Schedule>("DecodedSchedulingSolution", "The decoded scheduling solution represented as generalized schedule."));
+    }
+
+    public abstract Schedule CreateScheduleFromEncoding(T solution);
+
+    public override IOperation Apply() {
+      Schedule result = CreateScheduleFromEncoding(SchedulingSolutionParameter.ActualValue);
+      DecodedSchedulingSolutionParameter.ActualValue = result;
+      return base.Apply();
+    } 
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPEncodingTypes.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPEncodingTypes.cs	(revision 6177)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPEncodingTypes.cs	(revision 6177)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings {
+  public enum JSSPEncodingTypes {
+    JSMEncoding,
+    PRVEncoding
+  }
+}
